import re

inpage = False
inEnglish = False
numpages = 0
goods = 0
title = ""
tipe = ""
text = ""



def otherLang(line):
    return line[0:2] == "==" and line[len(line)-2:] == "==" and re.search(r'[^a-z ]', line[2:len(line)-2].lower()) == None


def transformRelation(tipe, rels):
    elems = []
    start = rels.find('{{l|en|')
    end = rels.find('}}')
    if start != -1:
        while start != -1 and end != -1:
            for e in rels[start+7:end].split("|"):
                if len(e) > 0 and e[0] != '-' and e[len(e)-1] != '-' and not e.isupper():
                    elems.append(e)
            rels = rels[end + 2:]
            start = rels.find('{{l|en|')
            end = rels.find('}}')


    if len(elems) == 0:
        return ""

    return "\n" + tipe + ": " + ','.join(filter(None, list(set(elems))))



def processContent(text):

    res = ""
    saveExample = False
    saveSynonyms = False
    syno = ""
    saveHyponyms = False
    hypo = ""
    saveHypernyms = False
    hyper = ""
    saveHolonyms = False
    holo = ""

    for line in text.split("\n"):

        line = line.strip()
        if len(line) == 0:
            continue

        
        if line[0:2] == "==" and line[len(line)-2:] == "==":
            saveHyponyms = False
            saveSynonyms = False
            saveHypernyms = False
            saveHolonyms = False
            l = line[2:len(line)-2].lower()
            if l.find("proper") != -1:
                return "\nproper "
            else:
                if l.find("noun") != -1:
                    res = res + "\nnoun "
                    saveExample = True
                else:
                    if l.find("adjective") != -1:
                        res = res + "\nadj "
                    else:
                        if l.find("verb") != -1:
                            res = res + "\nvrb "

            if l.find("hyponyms") != -1:
                saveHyponyms = True

            if l.find("synonyms") != -1:
                saveSynonyms = True

            if l.find("hypernyms") != -1:
                saveHypernyms = True

            if l.find("holonyms") != -1:
                saveHolonyms = True

        if saveHyponyms:
            hypo = hypo + line
        else:
            if saveSynonyms:
                syno = syno + line
            else:
                if saveHypernyms:
                    hyper = hyper + line
                else:
                    if saveHolonyms:
                        holo = holo + line 
                        

        if saveExample and line[0]=="#":
            saveExample = False

            pos = line.find("{{plural of|lang=en|")
            if pos != -1:
                pos = pos + 20
                end = line.find("}}", pos)
                return  "\nplural " + line[pos:end]
            else:
                definition = re.sub(r'\{.*\}', '', line[2:].replace("[[", "").replace("]]",""))
                definition = definition.strip().replace("&quot;", '"').replace("&lt;", '<').replace("&gt;", '>').replace("|", ' or ').replace("'''", "'").replace("''","'").replace("\n","")
                definition = re.sub(r'\<.*\>', '', definition)
                res = res + definition

            

    return res + transformRelation("hyponyms", hypo) + transformRelation("hypernyms", hyper) + transformRelation("synonyms", syno) + transformRelation("holonyms", holo)
    


outf = open('pages-extracted.txt', 'wt')

notittle = False

with open('enwiktionary-latest-pages-articles.xml', 'rt') as memfile:
    for line in memfile:

        line = line.strip()
        if len(line) == 0:
            continue

        if notittle:
            if line == "</page>":
                notittle = False
            continue

        if not inpage:
            if line == "<page>":
                if numpages % 10000 == 0:
                    print numpages

                inpage = True
                numpages = numpages + 1
                title = ""
                tipe = ""
                text = ""
                
        else:
            if line[0:7] == "<title>":
                title = line[7:line.find("</title>")].strip()
                if len(title) < 2 or title[0:len(title)-1].isupper() or re.search(r'[^a-zA-Z- ]', title) != None or title[0] == '-' or title[len(title)-1] == '-':
                    notittle = True
                    continue

            else:
                if "==English==" in line:
                    goods = goods + 1
                    inEnglish = True
                else:
                    if line == "</page>":
                        inpage = False
                        if len(text) > 0:
                            text = processContent(text)
                        else:
                            text = "\nnonenglish"

                        outf.write("\n------\n" + title + text)                            
                        inEnglish = False
           
                    else:
                        if inEnglish:
                            if otherLang(line):
                                inEnglish = False
                            else:
                                text = text + line + "\n"
                        

           
outf.close()

print "\n\n",numpages, goods
        
         

